#kernelDecl{accumulateTexture}{float4 *outBuf}# {
	#sharedMem# int maxValue;

	int myX = #globalThreadX#;
	int myY = #globalThreadY#;

	if (#threadX# == 0 && #threadY# == 0)
		maxValue = 0;
	#localSync#;

	float relX = #div{(float)myX}{512.0f}#;
	float relY = #div{(float)myY}{512.0f}#;
	float4 sample = #tex2DSample4{cubetex}{relX}{relY}#;

	int pixShuffle = ((myX+myY)%100);
	float outX = pixShuffle < 50 ? sample.x : 1.0f-sample.x;

	#atomicMax{&maxValue}{pixShuffle}#;
	#localSync#;

	#sincos{sample.z*3.14f + (float)maxValue*0.1f}{sample.x}{sample.y}#;

	sample.z += 0.01f;

	outBuf[myY*512 + myX] = #float4Ctor{outX}{sample.y}{sample.z}{1.0f}#;
}
